//
//  Winmail.h
//  TNEFsEnough3
//
//  Created by Josh Jacob on 5/27/11.
//  Copyright 2011 Josh Jacob. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "tnef-types.h"
#import "tnef-errors.h"

@class FileTableViewDataSource;

@interface Winmail : NSDocument <NSTableViewDelegate, NSStreamDelegate> {
@private
    
    // libytnef data
    TNEFStruct tnefStruct;
    char * cStringPath;
    
    // internal tnef data
    NSString * from;
    NSString * subject;
    NSDate * date;
    NSAttributedString *body;
    
    // table view data source
    FileTableViewDataSource * fileDataSource;
    
    // view outlets
    NSTextField *fieldFrom;
    NSTextField *fieldSubject;
    NSTextField *fieldDate;
    NSTableView *tableFiles;
    NSTextView *fieldBody;
    
    // export
    BOOL exportOne;
    NSURL * exportFile;
    NSURL * exportDir;
    NSMutableArray *exportArray;
    NSOutputStream *outputStream;
    
    // sheet
    NSWindow *savingSheet;
    NSTextField *savingSheetLabel;
    NSProgressIndicator *savingSheetProgress;
}

@property (nonatomic, retain) NSString * from;
@property (nonatomic, retain) NSString * subject;
@property (nonatomic, retain) NSDate * date;
@property (nonatomic, retain) NSAttributedString *body;

@property (nonatomic, retain) IBOutlet FileTableViewDataSource * fileDataSource;

@property (assign) IBOutlet NSTextField *fieldFrom;
@property (assign) IBOutlet NSTextField *fieldSubject;
@property (assign) IBOutlet NSTextField *fieldDate;
@property (assign) IBOutlet NSTableView *tableFiles;
@property (assign) IBOutlet NSTextView *fieldBody;

@property (nonatomic, retain) NSURL * exportFile;
@property (nonatomic, retain) NSURL * exportDir;
@property (nonatomic, retain) NSMutableArray *exportArray;
@property (nonatomic, retain) NSOutputStream *outputStream;
@property (assign) IBOutlet NSWindow *savingSheet;
@property (assign) IBOutlet NSTextField *savingSheetLabel;
@property (assign) IBOutlet NSProgressIndicator *savingSheetProgress;

- (IBAction) exportSelectedAttachment: (id) sender;
- (void) kickOffExport;
- (IBAction) exportAll: (id) sender;
- (void) exportSet: (NSArray *) rows;
- (void) kickOffExportAll;
- (void) kickOffExportAllNext;

@end
